<script lang="ts" setup>
import { onMounted, onUnmounted, ref } from "vue";
import axios, { AxiosError } from "axios";
import CodeHighlight from "../components/widgets/CodeHighlight.vue";
import Spinner from "../components/widgets/Spinner.vue";
import StopJobButton from "../components/widgets/StopJobButton.vue";
import { computed } from "@vue/reactivity";

const props = defineProps(["id", "executionId"]);

let poll = true;
let timerRef = 0;
const data = ref("");
const job = ref();
const execution = ref();

const logLines = ref(100);
const loading = ref(true);
const loadedOnce = ref(false);
async function loadData() {
  data.value = (
    await axios.get(
      `${window.origin}/api/jobs/${props.id}/logs?includeSourceTimestamps=true&lines=${logLines.value}`
    )
  ).data;

  job.value = (await axios.get(`${window.origin}/api/jobs/${props.id}`)).data;
  execution.value = (job.value?.executions as [])?.filter(
    (el: any) => el.id === props.executionId
  )[0];
}

const codeDiv = ref(null);
async function doPolling() {
  if (!poll) return;

  loading.value = true;
  try {
    await loadData();
  } catch (error) {
    console.log(error);
  }
  loading.value = false;
  loadedOnce.value = true;

  if (codeDiv.value != null) {
    (codeDiv.value as Element).scrollTop = (codeDiv.value as Element).scrollHeight;
  }

  timerRef = setTimeout(doPolling, 5000);
}

onMounted(() => {
  doPolling();
});

onUnmounted(() => {
  poll = false;
  clearTimeout(timerRef);
});

const stopJobError = ref();
const onStopClick = function () {
  stopJobError.value = undefined;
};
const onStopError = function (error: AxiosError) {
  stopJobError.value = error.message;
};
const showStopJobError = computed(() => {
  return typeof stopJobError.value !== "undefined";
});
const showStopJobButton = computed(() => {
  return (
    ((execution.value as any)?.status === "pending" ||
      (execution.value as any)?.status === "running") &&
    !(job.value as any).canceled
  );
});
</script>

<template>
  <div>
    <div class="flex justify-between">
      <p class="flex text-left mb-6 text-lg">
        JobId: {{ props.id }}<br />
        ExecutionId: {{ props.executionId }}<br />
        Status: {{ execution?.status ?? "Unknown" }}
      </p>
      <div class="flex flex-row">
        <Spinner v-if="loadedOnce && loading" :size="30" classes="flex items-top mr-4" />
        <div class="form-control">
          <label class="input-group input-group-sm">
            <span>Lines</span>
            <input type="text" class="input input-bordered input-sm" placeholder="" v-model="logLines" />
          </label>
        </div>
        <StopJobButton class="ml-4 h-10" :id="id" v-if="showStopJobButton" @click="onStopClick" @error="onStopError" />
      </div>
    </div>
  </div>
  <div v-if="!loadedOnce && loading">
    <Spinner />
  </div>
  <div v-else class="flex flex-col" style="height: 900px">
    <span v-if="showStopJobError" class="text-error">{{ stopJobError }}</span>
    <CodeHighlight language="log" :text="data" class="flex h-full" ref="codeDiv" :scroll="true" />
  </div>
</template>
